Package de.willuhn.jameica.hbci.server

# Class KontoauszugPdfUtil

java.lang.Object
de.willuhn.jameica.hbci.server.KontoauszugPdfUtil

public class KontoauszugPdfUtil extends Object
Hilfsklasse mit verschiedenen Util-Funktionen fuer die Kontoauszuege.

## Constructor Summary

Constructors
Constructor
Description
`KontoauszugPdfUtil()`

## Method Summary

Modifier and Type
Method
Description
`static String`
`createPath(Konto k, Kontoauszug ka)`
Erzeugt den Pfad fuer den zu speichernden Kontoauszug.
`static String`
`createPath(Konto k, Kontoauszug ka, String path, String folder, String name)`
Erzeugt den Pfad fuer den zu speichernden Kontoauszug.
`static void`
`delete(boolean deleteFiles, Kontoauszug... list)`
Loescht die angegebenen Kontoauszuege und bei Bedarf auch die Dateien.
`static File`
`getFile(Kontoauszug ka)`
Liefert das File-Objekt fuer diesen Kontoauszug.
`static List<org.kapott.hbci.GV_Result.GVRKontoauszug.Format>`
`getFormats(de.willuhn.util.TypedProperties bpd)`
Ermittelt die Liste der unterstuetzten Formate aus den BPD.
`static de.willuhn.datasource.GenericIterator<Kontoauszug>`
`getList(Object konto, Date from, Date to, boolean unread, boolean inclusive)`
Liefert eine gefilterte Liste von Kontoauszuegen.
`static Kontoauszug`
`getNewestWithNumber(Konto k)`
Liefert den aktuellsten Kontoauszug mit Nummer.
`static de.willuhn.datasource.GenericIterator<Kontoauszug>`
`getUnread()`
Liefert die Liste der noch ungelesenen Kontoauszuege.
`static void`
`markRead(boolean read, Kontoauszug... list)`
Markiert die Liste der angegebenen Kontoauszuege als gelesen.
`static void`
`receive(Kontoauszug k, byte[] data)`
Speichert den Kontoauszug im Dateisystem bzw.
`static void`
`store(Kontoauszug ka, File target)`
Speichert den Kontoauszug in einer Datei.
`static boolean`
`supported(Konto k)`
Prueft, ob elektronische Kontoauszuege im PDF-Format fuer dieses Konto unterstuetzt werden.
`static boolean`
`testPath(Konto k, String folder, String name)`
Prueft den Pfad fuer den zu speichernden Kontoauszug.
`static String`
`toString(Kontoauszug k)`
Liefert eine String-Repraesentation des Kontoauszuges.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### KontoauszugPdfUtil

public KontoauszugPdfUtil()

## Method Details

### getFile

public static File getFile(Kontoauszug ka) throws de.willuhn.util.ApplicationException
Liefert das File-Objekt fuer diesen Kontoauszug. Wenn er direkt im Filesystem gespeichert ist, wird dieses geliefert. Wurde er jedoch per Messaging gespeichert, dann ruft die Funktion ihn vom Archiv ab und erzeugt eine Temp-Datei mit dem Kontoauszug.

Parameters:
  `ka` - der Kontoauszug.
Returns:
  die Datei.
Throws:
  `de.willuhn.util.ApplicationException`

### store

public static void store(Kontoauszug ka, File target) throws de.willuhn.util.ApplicationException
Speichert den Kontoauszug in einer Datei.

Parameters:
  `ka` - der Kontoauszug.
  `target` - die Datei, in der der Kontoauszug gespeichert werden soll.
Throws:
  `de.willuhn.util.ApplicationException`

### receive

public static void receive(Kontoauszug k, byte[] data) throws RemoteException, de.willuhn.util.ApplicationException
Speichert den Kontoauszug im Dateisystem bzw. Messaging.

Parameters:
  `k` - der Kontoauszug. Er muss eine ID besitzen - also bereits gespeichert worden sein.
  `data` - die rohen Binaer-Daten.
Throws:
  `RemoteException`
  `de.willuhn.util.ApplicationException`

### createPath

public static String createPath(Konto k, Kontoauszug ka) throws RemoteException, de.willuhn.util.ApplicationException
Erzeugt den Pfad fuer den zu speichernden Kontoauszug.

Parameters:
  `k` - das Konto.
  `ka` - der Kontoauszug. Optional. Wenn er fehlt, werden Default-Werte verwendet.
Returns:
  der Pfad.
Throws:
  `RemoteException`
  `de.willuhn.util.ApplicationException`

### testPath

public static boolean testPath(Konto k, String folder, String name) throws RemoteException, de.willuhn.util.ApplicationException
Prueft den Pfad fuer den zu speichernden Kontoauszug.

Parameters:
  `k` - das Konto.
  `folder` - Template fuer den Unterordner.
  `name` - Template fuer den Dateinamen.
Returns:
  true, wenn der Pfad OK ist.
Throws:
  `RemoteException`
  `de.willuhn.util.ApplicationException`

### createPath

public static String createPath(Konto k, Kontoauszug ka, String path, String folder, String name) throws RemoteException, de.willuhn.util.ApplicationException
Erzeugt den Pfad fuer den zu speichernden Kontoauszug.

Parameters:
  `k` - das Konto.
  `ka` - der Kontoauszug. Optional. Wenn er fehlt, werden Default-Werte verwendet.
  `path` - Ordner, in dem die Kontoauszuege gespeichert werden.
  `folder` - Template fuer den Unterordner.
  `name` - Template fuer den Dateinamen.
Returns:
  der Pfad.
Throws:
  `RemoteException`
  `de.willuhn.util.ApplicationException`

### getUnread

public static de.willuhn.datasource.GenericIterator<Kontoauszug> getUnread() throws RemoteException
Liefert die Liste der noch ungelesenen Kontoauszuege.

Returns:
  die Liste der noch ungelesenen Kontoauszuege, chronologisch nach Erstellungsdatum sortiert. Neueste zuerst.
Throws:
  `RemoteException`

### getList

public static de.willuhn.datasource.GenericIterator<Kontoauszug> getList(Object konto, Date from, Date to, boolean unread, boolean inclusive) throws RemoteException
Liefert eine gefilterte Liste von Kontoauszuegen.

Parameters:
  `konto` - das optionale Konto. Kann auch der Name einer Kontogruppe sein.
  `from` - das optionale Start-Datum.
  `to` - das optionale End-Datum.
  `unread` - true, wenn nur ungelesene Kontoauszuege geliefert werden sollen.
  `inclusive` - true, wenn auch Kontoauszuege geliefert werden sollen, die nur in den Datumsbereich hineinreichen.
Returns:
  die Liste der passenden Kontoauszuege.
Throws:
  `RemoteException`

### getNewestWithNumber

public static Kontoauszug getNewestWithNumber(Konto k) throws RemoteException
Liefert den aktuellsten Kontoauszug mit Nummer.

Parameters:
  `k` - das Konto.
Returns:
  der Kontoauszug oder NULL, wenn er nicht existiert.
Throws:
  `RemoteException`

### delete

public static void delete(boolean deleteFiles, Kontoauszug... list)
Loescht die angegebenen Kontoauszuege und bei Bedarf auch die Dateien.

Parameters:
  `deleteFiles` - true, wenn auch die Dateien geloescht werden sollen.
  `list` - die zu loeschenden Kontoauszuege.

### markRead

public static void markRead(boolean read, Kontoauszug... list)
Markiert die Liste der angegebenen Kontoauszuege als gelesen. Jedoch nur, wenn sie nicht bereits als gelesen markiert sind.

Parameters:
  `read` - true, wenn die Kontoauszuege als gelesen werden sollen. Sonst false.
  `list` - die Liste der als gelesen zu markierenden Kontoauszuege.

### supported

public static boolean supported(Konto k)
Prueft, ob elektronische Kontoauszuege im PDF-Format fuer dieses Konto unterstuetzt werden.

Parameters:
  `k` - das zu pruefende Konto.
Returns:
  true, wenn es unterstuetzt wird.

### getFormats

public static List<org.kapott.hbci.GV_Result.GVRKontoauszug.Format> getFormats(de.willuhn.util.TypedProperties bpd)
Ermittelt die Liste der unterstuetzten Formate aus den BPD.

Parameters:
  `bpd` - die BPD.
Returns:
  die Liste der Formate. Nie NULL sondern hoechstens eine leere Liste.

### toString

public static String toString(Kontoauszug k) throws RemoteException
Liefert eine String-Repraesentation des Kontoauszuges.

Parameters:
  `k` - der Kontoauszug.
Returns:
  die String-Repraesentation.
Throws:
  `RemoteException`